local _, ns = ...; ns.SL_TUK = {};

local hook
local _E

local B = Stuffing

local bagUpdate = function(self)
	for bagID=0,4 do
		for slotID=1,GetContainerNumSlots(bagID) do
			local slotFrame = _G["TukuiBag_"..bagID.."_"..slotID]
			local slotLink = GetContainerItemLink(bagID,slotID)
			SyLevel:CallFilters('Tukbags', slotFrame, _E and slotLink)
		end
	end
end

local slotUpdate = function(self,b)
	local bagID, slotID = b.bag, b.slot
	if bagID and bagID >=0 and bagID <=4 and slotID then -- Prevents trying to update for bank slots
		local slotFrame = _G["TukuiBag_"..bagID.."_"..slotID]
		local slotLink = GetContainerItemLink(bagID,slotID)
		SyLevel:CallFilters('Tukbags', slotFrame, _E and slotLink)
	end
end


local update = function(self)
	bagUpdate(self)
end

local enable = function(self)
	_E = true

	if(not hook) then
		if B then
			hooksecurefunc(B,"BagSlotUpdate", bagUpdate)
			hooksecurefunc(B,"SlotUpdate", slotUpdate)
			hook = true
		end
	end
end

local disable = function(self)
	_E = nil
end

ns.SL_TUK.Tukbags = function()
	SyLevel:RegisterPipe('Tukbags', enable, disable, update, 'Tukui Bag Window', nil)
end
